import { LoadAxoOptions } from "./types";
import { BtModuleKeys } from "./lib/safeLoadBtModule/types";
declare global {
    interface Window {
        braintree: Partial<Record<BtModuleKeys, {
            create: () => void;
            VERSION: string;
        }>> & {
            fastlane?: unknown;
            loadFastlane?: ({ unminified, }: {
                unminified?: boolean;
            }) => Promise<unknown>;
        };
    }
}
/**
 * Loads accelerated checkout components.
 * @param options object with a minified parameter to determine if the script that is loaded should be minified or not (defaults to true if)
 * @returns an object with metadata with a localeUrl parameter to be read by AXO SDK
 */
declare function loadAxo(options: LoadAxoOptions): Promise<{
    fastlane: unknown;
    metadata: {
        localeUrl: string;
    };
}>;
export default loadAxo;
