/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */


function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var CDNX_PROD = "https://www.paypalobjects.com";
var LOAD_FASTLANE_SCRIPT = {
    minified: "load-fastlane",
    unminified: "load-fastlane.unminified",
};
var AXO_ASSET_PATH = "connect-boba";
var LOCALE_PATH = "".concat(AXO_ASSET_PATH, "/locales/");
var constants = {
    LOAD_FASTLANE_SCRIPT: LOAD_FASTLANE_SCRIPT,
    AXO_ASSET_PATH: AXO_ASSET_PATH,
    LOCALE_PATH: LOCALE_PATH,
    CDNX_PROD: CDNX_PROD,
};

var AxoSupportedPlatforms = {
    BT: "BT",
    PPCP: "PPCP",
};

var dist = {};

var scriptPromiseCache = {};
function loadScript$2(options) {
    var scriptLoadPromise;
    var stringifiedOptions = JSON.stringify(options);
    if (!options.forceScriptReload) {
        scriptLoadPromise = scriptPromiseCache[stringifiedOptions];
        if (scriptLoadPromise) {
            return scriptLoadPromise;
        }
    }
    var script = document.createElement("script");
    var attrs = options.dataAttributes || {};
    var container = options.container || document.head;
    script.src = options.src;
    script.id = options.id || "";
    script.async = true;
    if (options.type) {
        script.setAttribute("type", "".concat(options.type));
    }
    if (options.crossorigin) {
        script.setAttribute("crossorigin", "".concat(options.crossorigin));
    }
    Object.keys(attrs).forEach(function (key) {
        script.setAttribute("data-".concat(key), "".concat(attrs[key]));
    });
    scriptLoadPromise = new Promise(function (resolve, reject) {
        script.addEventListener("load", function () {
            resolve(script);
        });
        script.addEventListener("error", function () {
            reject(new Error("".concat(options.src, " failed to load.")));
        });
        script.addEventListener("abort", function () {
            reject(new Error("".concat(options.src, " has aborted.")));
        });
        container.appendChild(script);
    });
    scriptPromiseCache[stringifiedOptions] = scriptLoadPromise;
    return scriptLoadPromise;
}
loadScript$2.clearCache = function () {
    scriptPromiseCache = {};
};
var loadScript_1$1 = loadScript$2;

var loadStylesheet$1 = function loadStylesheet(options) {
    var stylesheet = document.querySelector("link[href=\"".concat(options.href, "\"]"));
    if (stylesheet) {
        return Promise.resolve(stylesheet);
    }
    stylesheet = document.createElement("link");
    var container = options.container || document.head;
    stylesheet.setAttribute("rel", "stylesheet");
    stylesheet.setAttribute("type", "text/css");
    stylesheet.setAttribute("href", options.href);
    stylesheet.setAttribute("id", options.id);
    if (container.firstChild) {
        container.insertBefore(stylesheet, container.firstChild);
    }
    else {
        container.appendChild(stylesheet);
    }
    return Promise.resolve(stylesheet);
};

Object.defineProperty(dist, "__esModule", { value: true });
dist.loadStylesheet = loadScript_1 = dist.loadScript = void 0;
var loadScript$1 = loadScript_1$1;
var loadScript_1 = dist.loadScript = loadScript$1;
var loadStylesheet = loadStylesheet$1;
dist.loadStylesheet = loadStylesheet;

var _a$1;
var BT_CDN_BASE_URL = "https://js.braintreegateway.com";
/**
 * Maps to the BT module namespace created on the window.braintree object
 */
var BT_MODULE = {
    Client: "client",
    HostedCardFields: "hostedFields",
};
var BT_ASSET_NAME = (_a$1 = {},
    _a$1[BT_MODULE.Client] = "client",
    _a$1[BT_MODULE.HostedCardFields] = "hosted-fields",
    _a$1);

/**
 * Safely loads BT modules by checking if the module already exists and verifying if versions mismatch
 *
 * @param loadConfig <BtModuleLoadConfig> Configuration of BT Module to load
 * @param version <string> version that should be passed from the client getVersion
 * @returns Promise<HTMLScriptElement>
 * @returns Promise<true> when BT module with same version already exists
 * @returns Promise.reject(err) when BT module already exists but versions mismatch or empty version passed in
 */
function safeLoadBtModule(loadConfig, version, minified) {
    var _a, _b;
    if (minified === void 0) { minified = true; }
    return __awaiter(this, void 0, void 0, function () {
        var bt, existingVersion;
        return __generator(this, function (_c) {
            bt = getBraintree();
            if (bt && bt[loadConfig.module]) {
                if (version && ((_a = bt[loadConfig.module]) === null || _a === void 0 ? void 0 : _a.VERSION) !== version) {
                    existingVersion = (_b = bt[loadConfig.module]) === null || _b === void 0 ? void 0 : _b.VERSION;
                    throw new Error("".concat(loadConfig.module, " already loaded with version ").concat(existingVersion, " cannot load version ").concat(version));
                }
                else {
                    return [2 /*return*/, true];
                }
            }
            if (!version) {
                throw new Error("Attempted to load ".concat(loadConfig.module, " without specifying version"));
            }
            return [2 /*return*/, loadBtModule(loadConfig, version, minified)];
        });
    });
}
/**
 * Reads the version and to load the correct version of Bt module
 *
 * @param loadConfig <BtModuleLoadConfig> Configuration of BT Module to load
 * @param version <string> Bt module version
 * @returns Promise<HTMLScriptElement> or
 */
function loadBtModule(loadConfig, version, minified) {
    if (minified === void 0) { minified = true; }
    var script = minified
        ? loadConfig.script.minified
        : loadConfig.script.unminified;
    return loadScript_1({
        id: "".concat(loadConfig.id, "-").concat(version),
        src: "".concat(BT_CDN_BASE_URL, "/web/").concat(version, "/js/").concat(script),
    });
}
/**
 * Looks for the Braintree web sdk on the window object
 *
 * @returns Braintree web sdk
 */
function getBraintree() {
    return window === null || window === void 0 ? void 0 : window.braintree;
}

var _a;
var btModulesLoadConfig = (_a = {},
    _a[BT_MODULE.Client] = {
        id: "client",
        module: BT_MODULE.Client,
        script: {
            unminified: "".concat(BT_ASSET_NAME[BT_MODULE.Client], ".js"),
            minified: "".concat(BT_ASSET_NAME[BT_MODULE.Client], ".min.js"),
        },
    },
    _a[BT_MODULE.HostedCardFields] = {
        id: "hcf",
        module: BT_MODULE.HostedCardFields,
        script: {
            unminified: "".concat(BT_ASSET_NAME[BT_MODULE.HostedCardFields], ".js"),
            minified: "".concat(BT_ASSET_NAME[BT_MODULE.HostedCardFields], ".min.js"),
        },
    },
    _a);

function loadScript(_a) {
    var src = _a.src, name = _a.name, id = _a.id, exportedName = _a.exportedName;
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                        var script = document.createElement("script");
                        script.type = "text/javascript";
                        script.src = src;
                        if (id) {
                            script.id = id;
                        }
                        script.addEventListener("load", function () { return __awaiter(_this, void 0, void 0, function () {
                            var exportedSymbol;
                            return __generator(this, function (_a) {
                                if (exportedName) {
                                    exportedSymbol = exportedName
                                        .split(".")
                                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                                        .reduce(function (result, key) { return result === null || result === void 0 ? void 0 : result[key]; }, window);
                                    resolve(exportedSymbol);
                                }
                                else {
                                    resolve(undefined);
                                }
                                return [2 /*return*/];
                            });
                        }); });
                        script.addEventListener("error", function () {
                            reject(new Error("Failed to load ".concat(name, " @ ").concat(src, ".")));
                        });
                        script.addEventListener("abort", function () {
                            reject(new Error("".concat(name, " @ ").concat(src, " load was aborted.")));
                        });
                        document.getElementsByTagName("head")[0].appendChild(script);
                    })];
                case 1: return [2 /*return*/, _b.sent()];
            }
        });
    });
}

/**
 * Loads accelerated checkout components.
 * @param options object with a minified parameter to determine if the script that is loaded should be minified or not (defaults to true if)
 * @returns an object with metadata with a localeUrl parameter to be read by AXO SDK
 */
function loadAxo(options) {
    return __awaiter(this, void 0, void 0, function () {
        var btSdkVersion, minified, localeUrl, fastlane;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    performance.mark("pp_axo_sdk_init_invoked");
                    btSdkVersion = options.btSdkVersion, minified = options.minified;
                    localeUrl = getLocaleUrl(options);
                    if (!(options.platform === AxoSupportedPlatforms.BT)) return [3 /*break*/, 2];
                    return [4 /*yield*/, Promise.all([
                            safeLoadBtModule(btModulesLoadConfig.hostedFields, btSdkVersion, minified),
                        ])];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 2:
                    if (!(options.platform === AxoSupportedPlatforms.PPCP)) return [3 /*break*/, 4];
                    return [4 /*yield*/, Promise.all([
                            safeLoadBtModule(btModulesLoadConfig.client, btSdkVersion, minified),
                            safeLoadBtModule(btModulesLoadConfig.hostedFields, btSdkVersion, minified),
                        ])];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 4: throw new Error("unsupported Fastlane platform");
                case 5: return [4 /*yield*/, loadScript({
                        id: "load-fastlane",
                        src: getAssetPath(options),
                        name: "loadFastlane",
                        exportedName: "braintree.loadFastlane",
                    })];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, window.braintree.loadFastlane({
                            unminified: !minified,
                        })];
                case 7:
                    fastlane = _a.sent();
                    delete window.braintree.loadFastlane;
                    return [2 /*return*/, { fastlane: fastlane, metadata: { localeUrl: localeUrl } }];
            }
        });
    });
}
/**
 * Prepends the domain to the asset url
 * @param options object with assetUrl and bundleid parameters to determine which URL to return
 * @returns full domain and assets URL as string
 */
function generateAssetUrl(_a) {
    var assetPath = _a.assetPath, bundleId = _a.bundleId;
    return bundleId
        ? "https://cdn-".concat(bundleId, ".static.engineering.dev.paypalinc.com/").concat(assetPath)
        : "".concat(constants.CDNX_PROD, "/").concat(assetPath);
}
/**
 * Retrieves either the minified or unminified assets URL as specified
 * @param options (Optional) object with a minified and metadata with bundleIdOverride parameters to determine which URL to return
 * @returns assets URL as string
 */
function getAssetPath(options) {
    var _a;
    var assetName = (options === null || options === void 0 ? void 0 : options.minified) !== false
        ? constants.LOAD_FASTLANE_SCRIPT.minified
        : constants.LOAD_FASTLANE_SCRIPT.unminified;
    var assetPath = "".concat(constants.AXO_ASSET_PATH, "/").concat(assetName, ".js");
    return generateAssetUrl({
        assetPath: assetPath,
        bundleId: (_a = options === null || options === void 0 ? void 0 : options.metadata) === null || _a === void 0 ? void 0 : _a.bundleIdOverride,
    });
}
/**
 * Retrieves the Locales URL, the path to our language files
 * @param options (Optional) object with a minified and metadata with bundleIdOverride parameters to determine which URL to return
 * @returns locale URL as string
 */
function getLocaleUrl(options) {
    var _a;
    return generateAssetUrl({
        assetPath: constants.LOCALE_PATH,
        bundleId: (_a = options === null || options === void 0 ? void 0 : options.metadata) === null || _a === void 0 ? void 0 : _a.bundleIdOverride,
    });
}

export { constants, loadAxo };
