import { BT_ASSET_NAME, BT_MODULE } from "./constants";

export type BtModuleKeys = (typeof BT_MODULE)[keyof typeof BT_MODULE];

export type BtModuleLoadConfig = {
  id: string;
  module: BtModuleKeys;
  script: {
    unminified: string;
    minified: string;
  };
};

export const btModulesLoadConfig: Record<BtModuleKeys, BtModuleLoadConfig> = {
  [BT_MODULE.Client]: {
    id: "client",
    module: BT_MODULE.Client,
    script: {
      unminified: `${BT_ASSET_NAME[BT_MODULE.Client]}.js`,
      minified: `${BT_ASSET_NAME[BT_MODULE.Client]}.min.js`,
    },
  },
  [BT_MODULE.HostedCardFields]: {
    id: "hcf",
    module: BT_MODULE.HostedCardFields,
    script: {
      unminified: `${BT_ASSET_NAME[BT_MODULE.HostedCardFields]}.js`,
      minified: `${BT_ASSET_NAME[BT_MODULE.HostedCardFields]}.min.js`,
    },
  },
};
